// Bentigt GLUT!
// Fr Dev-C++ (also Mingw32) siehe http://sites.netscape.net/ptrpck/glut.htm
// mit GLUT linken: Project/Project options/Further object files or linker options:
// -lopengl32 -lglu32 -lglut32

// Korrekturen fr GLUT in Dev-C++:
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE

#include <gl/glut.h>
#include "vector2d.h"

// Kraft durch Masse
Vector2D f(Vector2D r)
{
    double len = r.length();
    return (-1.0/(len*len*len)) * r; // Kraft zeigt zum Ursprung, Betrag ist 1/Abstandsquadrat (!)
}

// Euler-Verfahren
void drawEuler()
{
    Vector2D r(1.0, 0.0);
    Vector2D v(0.0, 0.7);
    const double dt = 1.0e-3;
    double t;
    for(t = 0.0; t < 500.0; t += dt)
    {
        glColor3f(0.0, 1.0, 0.0);
        r.plot();
        Vector2D r1 = r;
        r = r + dt*v;
        v = v + dt*f(r1); // alter r-Wert benutzt!
    }
}

// Leap-Frog-Verfahren
void drawLeapFrog()
{
    Vector2D r(1.0, 0.0);
    Vector2D v(0.0, 0.7);
    const double dt = 1.0e-3;
    double t;
    for(t = 0.0; t < 500.0; t += dt)
    {
        glColor3f(1.0, 0.0, 0.0);
        r.plot();
        r = r + dt*v;
        v = v + dt*f(r); // neuer r-Wert benutzt!
    }
}

void renderScene()
{
    glClear(GL_COLOR_BUFFER_BIT);

    glPointSize(2);

    //Antialiasing fr Punkte und Linien
    glEnable(GL_POINT_SMOOTH);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

    glBegin(GL_POINTS);
        drawEuler();
        drawLeapFrog();
    glEnd();

    glFlush();
}

void changeSize(GLsizei w, GLsizei h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(-2.0, 2.0, -2.0, 2.0);
}

int main(int argc, char* argv[])
{
    glutInit(&argc, argv);

    glutInitWindowSize(600, 600);
    glutInitWindowPosition(20, 25);

    // Standard: glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
    glutCreateWindow("Zweikrperproblem");

    glutDisplayFunc(renderScene);
    glutReshapeFunc(changeSize);

    glutMainLoop();

    return 0; // nie erreicht
}
